#include <iostream>
using namespace std;
int main(){
     
    int objectNum = 0;
    int validCount = 0;
    int iterNum = 0;
    int located = 0 ;
    int transNum = 0;
    float supportThr;

    const int n = 20;
    const int m = 500;
     
    int a = 0;
    cin >> objectNum >> transNum >> supportThr;
    bool trans[m][n];
    bool test[n];
    bool transValid[m];
     
    // test & trans init
    for(int j = 0; j < objectNum; j++){
        test[j] = false;
    }
     
    for(int i = 0; i < transNum; i++){
        for(int j = 0; j < objectNum; j++){
            trans[i][j] = false;
        }
    }

    // take input transform into matrix form
    for(int i = 0; i < transNum; i++){
        cin >> iterNum;
        for(int j = 0; j < iterNum; j++){
            cin >> located;
            trans[i][located - 1] = true;
             
        }
    }
     
    cin >> iterNum;
     
    // take testing data
    for(int j = 0; j < iterNum; j++){
        cin >> located;
        test[located - 1] = true;
    }
     
 
    // compute support set with test data
    for(int i = 0; i < transNum; i++){
        transValid[i] = false;
        bool sign = true;
        for(int j = 0; j < objectNum; j++){
            if(test[j] == 1 && trans[i][j] == 0)
                sign = false;
        }
        if(sign == true){
            transValid[i] = true;
            validCount++;
        }
    }
     
    // calculate confidence with threshold of suppport
     
    int maxIndex = -1;
    int maxCount = -1;
    for(int i = 0; i < objectNum; i++){
        if(test[i] == 1)
            continue;
        int count = 0;
        for(int j = 0; j < transNum; j++){
            if(transValid[j] && trans[j][i])
                count++;
        }
         
        if( count > supportThr * transNum && count > maxCount)   
        {
            maxCount = count;
            maxIndex = i;
        }
    }
    if(maxCount != -1){
        cout << (maxIndex + 1) << " " << maxCount << " " << validCount ;
    }
 
    return 0;
}